package HomeMade.Tracking;

import ij.IJ;
import java.util.Arrays;
import java.util.List;
import java.lang.Math;
import java.util.ArrayList;
import HomeMade.Tracking.*;
import ij.*;

public class FociTracking {
	public static void trackmyFoci(data Data){	
		double[] area = Data.area;
		double[] x_coord = Data.x;
		double[] y_coord = Data.y;
		double[] frame = Data.frame;	
		String ColorSet=Data.ColorSet;
		ImagePlus imp =Data.imp;	
		double x_coordmax = 0;
		double y_coordmax = 0;
		for (int i=0; i<x_coord.length; i++){
			if (x_coord[i]>x_coordmax){
				x_coordmax=x_coord[i];
			}
			if (y_coord[i]>y_coordmax){
				y_coordmax=y_coord[i];
			}
		}	
		double areasum = 0;
		for (int i=0; i<area.length; i++){
			areasum = areasum + area[i];
		}
		double two_foci = 1.5*areasum/area.length;
		double three_foci = 1.5*two_foci;
		double L=Math.ceil(Math.max(x_coordmax,y_coordmax));
		int delx = (int)L;
		int dely = (int)L;
		double dx = L/delx;
		double dy = L/dely;
		int startiter = (int) frame[1];
		int enditer = (int) frame[frame.length-1];
		int rangesize = Data.trackRange;;
		int objnum = 0;
		int found=0;
		ObjectArray OA = new ObjectArray(enditer);
		space s = new space(delx,dely);		

		OAindices OAi = new OAindices(enditer);
		
		Integer[] indicestrial = new Integer[0];
		int counter = 0;
		
		// Create the first space
		while(frame[objnum] == startiter){
			//IJ.log(""+startiter+" "+objnum+" "+frame[objnum]);
			//int fr = (int)frame[objnum];
			int ii = (int)Math.floor(x_coord[objnum]);
			int jj = (int)Math.floor(y_coord[objnum]);
			
			FociObject Foci = new FociObject(objnum+1, x_coord[objnum], y_coord[objnum], frame[objnum]);			
			s.addtospace(ii, jj, Foci);	
			//System.out.print(Foci.x_coord);			
			OA.add(startiter-1, Foci);
			OAi.add(startiter-1, Foci.FOindex);
			
			objnum++;	
			
			indicestrial = OAi.find(0, Foci.FOindex);
			counter++;
		}

		// Resize OA
		OA.resize(startiter-1);
		OAi.resize(startiter-1);

		// Add these objects to the correct frame (startiter-1)
		// ObjectArray.set(startiter-1, Object);
		int prevFrame=0;
		for (int iter=startiter+1; iter<=enditer; iter++){ // going through all objects
			//int istart=objnum;

			List<FociObject> toaddtospace = new ArrayList<FociObject>(0);


			
			
			while (frame[objnum]==iter){
				for (int cc=1;cc<frame.length;cc++){ // this will add the objects to space we need to analyze as well in the next frame unfortunately five times
					if (!(prevFrame==iter)){
						if (frame[cc]<=frame[objnum]&&frame[cc]>=frame[objnum]-3){
							FociObject FociAdd = new FociObject(cc+1, x_coord[cc], y_coord[cc], frame[cc]);
							int ee = (int)Math.floor(x_coord[cc]);
							int ff = (int)Math.floor(y_coord[cc]);
						
							FociAdd.setcoords(ee,ff);
							if (toaddtospace.indexOf(FociAdd)==-1){
								toaddtospace.add(FociAdd);
								IJ.log(""+ee+","+ff);
							}
						}
						prevFrame=(int)frame[cc];
					}
					
				}
				IJ.log("--");
			
				FociObject CurrentFoci = new FociObject(objnum+1, x_coord[objnum], y_coord[objnum], frame[objnum]);
				
				int ii = (int)Math.floor(x_coord[objnum]);
				int jj = (int)Math.floor(y_coord[objnum]);
				
				int neighbour = 0;
				
				int firsttry = 1;
				int spaceindex = 1;
				int range = 1;
				
				DistanceVector[] dist;
				dist = new DistanceVector[10];
				
				int distsize = 0;
				ArrayList<Neighbour> distancelist = new ArrayList<Neighbour>();
				found=0;
				while (neighbour==0){
					
					if(firsttry<=rangesize){
						range = firsttry;
						spaceindex = 1;
						//IJ.log(""+firsttry+", "+rangesize+","+Data.trackRange);
						//IJ.log("ft"+firsttry+", "+rangesize+","+Data.trackRange+", condition "+(firsttry<=rangesize)+", "+range );
					}else{
						//IJ.log("ft"+firsttry+", "+rangesize+","+Data.trackRange+", condition "+(firsttry<=rangesize)+", "+range +" iter"+iter+", sp"+spaceindex);
						if(firsttry>rangesize&&spaceindex<3){
							
							IJ.log("searching over time");
							range = (firsttry % rangesize);
							if (range ==0){
								range=rangesize;
							}
							spaceindex = (int)Math.floor((firsttry-1)/rangesize);	
												
							//IJ.log(""+firsttry+", "+rangesize+","+Data.trackRange+", "+range);
							// here we need to add to the space the non connected ones from before, or don't reset the space and remove once a neighbour has been found
						}else{
							//neighbour = 1;
							IJ.log("no neighbour found from "+ii+","+jj);
							found=1;
							break;
						}
					}
					
					for (int aa=(ii-rangesize);aa<=(ii+rangesize);aa++){// changed to rangesize @2-5-17, meaning we add all neighbours over the frames in space
						for (int bb=(jj-rangesize);bb<=(jj+rangesize);bb++){
							if (aa >= 0 && bb >= 0 && aa < delx && bb < dely){
								
								ArrayList<FociObject> xlist = s.get(aa, bb);
								int xx = xlist.size();
								
								for (int qq=0;qq<xx;qq++){
									FociObject F = xlist.get(qq);
									//int obj_num = space[iter-spaceindex-1][aa][bb][xx].FOindex;
									double del_x = (x_coord[objnum]-F.x_coord);
									double del_y = (y_coord[objnum]-F.y_coord);
									double distance = Math.sqrt((del_x*del_x)+(del_y*del_y));
									
									Neighbour N = new Neighbour(F,distance, aa, bb);
									if (!distancelist.contains(N)){
										distancelist.add(N);
									}

									//Map<Integer, Double> dist1 = new HashMap<Integer, Double>();
									//dist1.keySet<(int)F.FOindex> (double)distance;
									
									//dist[dist.length] = new DistanceVector(iter-spaceindex, obj_num, distance);
									//distvalues[distvalues.length] = distance;
									//distsize++;
									neighbour=1;
																		
									found+=1;
									if ((x_coord[objnum]<103 &&x_coord[objnum]>102)||ii==84){
										IJ.log("neighbour from "+F.x_coord+","+F.y_coord+", @ "+ x_coord[objnum]+","+y_coord[objnum]+", iter: "+iter+", found: "+found);
									} 
								}
							}	
						}
					}
					firsttry++;
				}
				//objnum++;
						
				if (neighbour==1){ // There is a match!
					
					//Arrays.sort(distvalues);
					Arrays.sort(distancelist.toArray());
					distsize = distancelist.size();
					
					//DistanceVector[] newdist;
					//newdist = new DistanceVector[dist.length];
					
					// Sort the dist array and create newdist		
					//for(int k=0;k<distvalues.length;k++){
					//	for (int j=0;j<dist.length;j++){
					//		if (dist[j].distance == distvalues[k]){
					//			newdist[k]=dist[j];
					//		}
					//	}
					//}
					
					FociObject[] posobj = new FociObject[0];
					
					if (distsize>1){
						IJ.log("mapping first out of "+distsize);
						if (distsize==10){
							for (int uu=0;uu<distsize;uu++){
								IJ.log(""+distancelist.get(uu).getdist()+","+distancelist.get(uu).getF().getfr());
							}
						}
						


						if (area[objnum]<two_foci){
							posobj = new FociObject[1];
							posobj[0] = (distancelist.get(0)).getF();
							//s.remove(distancelist.get(0).getX(),distancelist.get(0).getY(), distancelist.get(0).getF());
							
						} else {
							IJ.log("mapping two neighbours");
							if ((area[objnum]<three_foci) && (dist.length>1)) {
								posobj = new FociObject[2];
								posobj[0] = (distancelist.get(0)).getF();
								posobj[1] = (distancelist.get(1)).getF();
								//s.remove(distancelist.get(0).getX(),distancelist.get(0).getY(), distancelist.get(0).getF());
								//s.remove(distancelist.get(1).getX(),distancelist.get(1).getY(), distancelist.get(1).getF());
							} else { if (dist.length>2) {
								posobj = new FociObject[3];
								posobj[0] = (distancelist.get(0)).getF();
								posobj[1] = (distancelist.get(1)).getF();
								posobj[2] = (distancelist.get(2)).getF();
								//s.remove(distancelist.get(0).getX(),distancelist.get(0).getY(), distancelist.get(0).getF());
								//s.remove(distancelist.get(1).getX(),distancelist.get(1).getY(), distancelist.get(1).getF());
								//s.remove(distancelist.get(2).getX(),distancelist.get(2).getY(), distancelist.get(2).getF());
							}
							
						}
					}
					
				} else {
					posobj = new FociObject[1];
					//IJ.showMessage("neighbour =" + neighbour + "distsize =" + distsize);
					posobj[0] = (distancelist.get(0)).getF();
					//s.remove(distancelist.get(0).getX(),distancelist.get(0).getY(), distancelist.get(0).getF());
					
				 }
					//int[] index;
					//index = new int[10];
					
					//Integer[] indices = new Integer[0];
					Integer[] indicesOAi = new Integer[0];
					
					// Track all the objects
					for (int m=0;m<posobj.length;m++){
						
						//indices = OA.find(iter-spaceindex-1, posobj[m]);
						indicesOAi = OAi.find(iter-spaceindex-1, posobj[m].FOindex);					
						
						if (indicesOAi.length>0){
							if (indicesOAi.length == 1){
							    //if (!OA.get(iter-1, indices[0])){
								if (!OAi.get(iter-1,indicesOAi[0])){ //checks is the object is already used
									//if (ii==102||ii==84){IJ.log(""+posobj.length+","+!OAi.get(iter-1,indicesOAi[0]));}
									OAi.set(iter-1, indicesOAi[0], CurrentFoci.FOindex);
									OA.set(iter-1,indicesOAi[0],CurrentFoci);
								} else { // if not add it, this screws up going back in time since if the foci is found multiple times there is still a neighbour but it is not allowed so nothing is going into the data
									if (spaceindex == 1){
										
										double x_cur = OA.getreal(iter-1,indicesOAi[0]).x_coord;
										double y_cur = OA.getreal(iter-1,indicesOAi[0]).y_coord;
										
										double x_1 = OA.getreal(iter-spaceindex-1,indicesOAi[0]).x_coord;
										double y_1 = OA.getreal(iter-spaceindex-1,indicesOAi[0]).y_coord;
										
										double del_xold = ((x_cur-x_1)*(x_cur-x_1));
										double del_yold = ((y_cur-y_1)*(y_cur-y_1));
										
										double dist_old = Math.sqrt(del_xold + del_yold);
										
										if (distancelist.get(m).getdist() < dist_old){
											
											// Place current values in new position
											
											OA.add(iter-1,OA.getreal(iter-1,indicesOAi[0]));										
											OA.set(iter-1, indicesOAi[0], CurrentFoci);
											
											OAi.add(iter-1, OA.getreal(iter-1, indicesOAi[0]).FOindex);
											OAi.set(iter-1, indicesOAi[0], CurrentFoci.FOindex);
											
										} else {
											
											OA.add(iter-1,CurrentFoci);
											OAi.add(iter-1,CurrentFoci.FOindex);
										}
									} else {
										
										OA.add(iter-1,CurrentFoci);
										OAi.add(iter-1, CurrentFoci.FOindex);
										}																																		
								}
							} else { // Multiple instances to check
								double theta[];
								theta = new double[2];
								
								for (int kk=0;kk<indicesOAi.length;kk++){
									double x_now = OA.getreal(iter-spaceindex-1,indicesOAi[kk]).x_coord;
									double y_now = OA.getreal(iter-spaceindex-1,indicesOAi[kk]).y_coord;
													
									double x_prev = OA.getreal(iter-(spaceindex+1)-1,indicesOAi[kk]).x_coord; 
									double y_prev = OA.getreal(iter-(spaceindex+1)-1,indicesOAi[kk]).y_coord;
									
									double vector1 = Math.sqrt(((x_coord[objnum]-x_now)*(x_coord[objnum]-x_now))+((y_coord[objnum]-y_now)*(y_coord[objnum]-y_now)));
									double vector2 = Math.sqrt(((x_coord[objnum]-x_prev)*(x_coord[objnum]-x_prev))+((y_coord[objnum]-y_prev)*(y_coord[objnum]-y_prev)));
								
									double dot = ((x_now-x_coord[objnum])*(x_prev-x_coord[objnum]))+((y_now-y_coord[objnum])*(y_prev-y_coord[objnum]));
									theta[kk] = Math.acos(dot/(vector1*vector2));
									theta[kk] = Math.abs(theta[kk]-Math.PI/2);
								}
								double[] thetaori = theta;
								Arrays.sort(theta);
								
								// Find index
								for (int sorter=0;sorter<theta.length;sorter++){
									if (thetaori[sorter] == theta[0]){
										OA.set(iter-1, indicesOAi[sorter], CurrentFoci);
										OAi.set(iter-1, indicesOAi[sorter], CurrentFoci.FOindex);
									}
								}
							}
								
						} else {
							OA.add(iter-1,CurrentFoci);
							OAi.add(iter-1, CurrentFoci.FOindex);
						}
					}
				}
				objnum++;
				if (objnum==frame.length){
					break;
				}
			}						
			// Clear space
			s.empty();
			s = new space(delx,dely);						

			
			// Make the new space
			FociObject[] toadd = toaddtospace.toArray(new FociObject[toaddtospace.size()]);
			
			for(int i=0; i<toadd.length; i++){
				int ii = toadd[i].ii;
				int jj = toadd[i].jj;
				
				s.addtospace(ii,jj,toadd[i]);
				counter++;
			}
			
			//IJ.log("space size"+s.size()+","+toadd.length);			
			OA.resize(iter-1);
			OAi.resize(iter-1);
			
			}
		// Now return the ObjectArray
		
		IJ.log("Tracking done!");
		//PlotData.plot(OAi, OA);
		PlotDataJoost.plot(OAi,OA, ColorSet, imp);  //edited out but dont know why feb 2016
		PlotData.plot(OAi, OA, Data.directory);
   //same
		}
	}


