package HomeMade.Tracking;

import ij.IJ;
import java.util.Arrays;
import java.util.List;
import java.lang.Math;
import java.util.ArrayList;
import HomeMade.Tracking.*;
import ij.*;

public class FociTrackingNew {
	public static void trackmyFoci(data Data){	
		double[] area = Data.area;
		double[] x_coord = Data.x;
		double[] y_coord = Data.y;
		double[] frame = Data.frame;	
		String ColorSet=Data.ColorSet;
		ImagePlus imp =Data.imp;	
		double x_coordmax = 0;
		double y_coordmax = 0;
		double areasum = 0;
		
		for (int i=0; i<x_coord.length; i++){ // this loops through all objects as of 4-5-17 also adds up areas
			if (x_coord[i]>x_coordmax){
				x_coordmax=x_coord[i];
			}
			if (y_coord[i]>y_coordmax){
				y_coordmax=y_coord[i];
			}
			areasum = areasum + area[i];
		}	
		double two_foci = 1.5*areasum/area.length; // needed to map the amount of times a focus can be a neighbour
		double three_foci = 1.5*two_foci;

		
		TimePoint[] t = new TimePoint[frame.length-1];// make the timepoint array
		for (int i=0; i<frame[frame.length-1];i++){ // initiate the timepoints within the array
			t[i]= new TimePoint((int)Math.floor(x_coordmax)+1,(int)Math.floor(y_coordmax)+1);
		}
		for (int i=0; i< frame.length;i++){// this loops through all objects and adds all points in the space
			t[(int)frame[i]-1].alist[(int)Math.floor(x_coord[i])][(int)Math.floor(y_coord[i])]=new FociObject (i+1, x_coord[i], y_coord[i], frame[i]);
			IJ.log("mapped"+ (int)Math.floor(x_coord[i])+","+(int)Math.floor(y_coord[i])+",@fram "+((int)frame[i]-1));
		}
		//IJ.log("x"+x_coordmax+",y "+y_coordmax);
		double L=Math.ceil(Math.max(x_coordmax,y_coordmax));//determine the maximum coordinate size
		int delx = (int)Math.floor(x_coordmax);
		int dely = (int)Math.floor(y_coordmax);
		double dx = L/delx;
		double dy = L/dely;
		int startiter = (int) frame[1]; //get the first frame number
		int enditer = (int) frame[frame.length-1]; // find the last frame number
		int rangesize = Data.trackRange;
		int gapRange = Data.gapRange; 
		int objnum = 0;
		ObjectArray OA = new ObjectArray(enditer);
		space s = new space(delx,dely);		
		OAindices OAi = new OAindices(enditer);
		Integer[] indicestrial = new Integer[0];
		int counter = 0;

		// Resize OA
		OA.resize(startiter-1);
		OAi.resize(startiter-1);

		for (int iter=startiter; iter<=enditer; iter++){ // going through all frames starting from the 1st, otherwise the objnum does not increase properly frame
			while (frame[objnum]==iter){ // while we are in the same frame, cannot start from iter 2 since then all objects from the first frame are ignored
				if (iter==1){
					objnum++;
				} else {
					FociObject CurrentFoci = new FociObject(objnum+1, x_coord[objnum], y_coord[objnum], frame[objnum]);
					int ii = (int)Math.floor(x_coord[objnum]);
					int jj = (int)Math.floor(y_coord[objnum]);
					int neighbour = 0;
					int firsttry = 1;
					int spaceindex = -1;
					int curSp=0;
					int range = 1;
					DistanceVector[] dist;
					dist = new DistanceVector[10];
					int distsize = 0;
					ArrayList<Neighbour> distancelist = new ArrayList<Neighbour>();
					
					for (int tt=spaceindex;tt>=-gapRange;tt--){ // start at frame -1 and go back further if possible
						//IJ.log(""+tt+", "+neighbour);
						while (neighbour==0){ // as long as there is no neighbour
							if (frame[objnum]+tt>=0){ // only check real frames, needed to prevent going before the start of the movie in the initial frames
								for (int aa=(ii-range);aa<=(ii+range);aa++){ // look at objects x pos 
									for (int bb=(jj-range);bb<=(jj+range);bb++){ // look at objects y pos
										if (aa >= 0 && bb >= 0 && aa <= delx && bb <= dely /*&& (aa==ii-range ||aa==ii+range)&&(bb==ii-range||bb==ii-range)*/){ // aa< ro equal to otherwise borders are missed!
	
											FociObject F = t[(int)(frame[objnum]+tt)-1].alist[aa][bb]; // start the frame before the one currently , works with -1 since this is how it is put into the array before. (framenumbers from 1-100, array index from 0-99)
											if (!(F==null)){
												//IJ.log("g8");
												double del_x = (x_coord[objnum]-F.x_coord);
												double del_y = (y_coord[objnum]-F.y_coord);
												double distance = Math.sqrt((del_x*del_x)+(del_y*del_y))*-tt;
												
												Neighbour N = new Neighbour(F,distance, aa, bb);
												distancelist.add(N);
												neighbour=1;
												if ( 92<x_coord[objnum]&&x_coord[objnum]<96){
													IJ.log("tt:"+tt+" , "+iter);
													IJ.log(""+x_coord[objnum]+","+y_coord[objnum]+","+frame[objnum]+","+F.x_coord+","+F.y_coord+","+F.frame);
													IJ.log("dist "+distance);
													
												}
												curSp=tt;
											}
										}	
									}
								}
								//IJ.log(""+range);
								range++;
								if (range>rangesize){
									break;
								}
								firsttry++;
							} else {
								break;
							}
							
						}
						
					}
					if (neighbour==1){ // There is a match!
						//IJ.log("g8");
						Arrays.sort(distancelist.toArray());
						distsize = distancelist.size();
						FociObject[] posobj = new FociObject[0];
						
						if (distsize>1){
							if (area[objnum]<two_foci){
								posobj = new FociObject[1];
								posobj[0] = (distancelist.get(0)).getF();
								IJ.log("testing "+posobj[0].frame);
							} else {
								IJ.log("mapping two neighbours");
								if ((area[objnum]<three_foci) && (dist.length>1)) {
									posobj = new FociObject[2];
									posobj[0] = (distancelist.get(0)).getF();
									posobj[1] = (distancelist.get(1)).getF();
								} else { 
									if (dist.length>2) {
									posobj = new FociObject[3];
									posobj[0] = (distancelist.get(0)).getF();
									posobj[1] = (distancelist.get(1)).getF();
									posobj[2] = (distancelist.get(2)).getF();
									}
								}
							}
						} else {
							posobj = new FociObject[1];
							//IJ.log("neighbour =" + neighbour + "distsize =" + distsize+","+curSp);
							posobj[0] = (distancelist.get(0)).getF();
							IJ.log(""+posobj[0].frame);
						}
						Integer[] indicesOAi = new Integer[0];
						// Track all the objects
						for (int m=0;m<posobj.length;m++){
							IJ.log("adding");
							//indices = OA.find(iter-spaceindex-1, posobj[m]);
							//IJ.log("iter"+ iter+","+(posobj[m].FOindex));
							indicesOAi = OAi.find(iter+curSp-1, posobj[m].FOindex);	// first iter +curSp-1, but that leads to searching at -1 in the first frame
							//IJ.log("added" + OA.getreal(iter-1,indicesOAi[0]).x_coord+", "+ OA.getreal(iter-1,indicesOAi[0]).y_coord +","+OA.getreal(iter+curSp-1,indicesOAi[0]).x_coord+","+OA.getreal(iter+curSp-1,indicesOAi[0]).y_coord);
							IJ.log("csp"+curSp);
							if (indicesOAi.length>0){
								IJ.log("found: "+indicesOAi.length);
								if (indicesOAi.length == 1){ // this happens if this is only one object
								    //if (!OA.get(iter-1, indices[0])){
									if (!OAi.get(iter-1,indicesOAi[0])){ //checks is the object is already used
										OAi.set(iter-1, indicesOAi[0], CurrentFoci.FOindex);
										OA.set(iter-1,indicesOAi[0],CurrentFoci);
										
									} else { // if not add it, this screws up going back in time since if the foci is found multiple times there is still a neighbour but it is not allowed so nothing is going into the data
										if (curSp <= -1){
											IJ.log("curSp "+curSp);
											
											double x_cur = OA.getreal(iter-1,indicesOAi[0]).x_coord;
											double y_cur = OA.getreal(iter-1,indicesOAi[0]).y_coord;
											
											double x_1 = OA.getreal(iter+curSp-1,indicesOAi[0]).x_coord;
											double y_1 = OA.getreal(iter+curSp-1,indicesOAi[0]).y_coord;
											
											double del_xold = ((x_cur-x_1)*(x_cur-x_1));
											double del_yold = ((y_cur-y_1)*(y_cur-y_1));
											
											double dist_old = Math.sqrt(del_xold + del_yold);
											
											if (distancelist.get(m).getdist() < dist_old){
												
												// Place current values in new position
												//IJ.log("added");
												OA.add(iter-1,OA.getreal(iter-1,indicesOAi[0]));										
												OA.set(iter-1, indicesOAi[0], CurrentFoci);
												
												OAi.add(iter-1, OA.getreal(iter-1, indicesOAi[0]).FOindex);
												OAi.set(iter-1, indicesOAi[0], CurrentFoci.FOindex);
												
											} else {
												//IJ.log("added 1");
												OA.add(iter-1,CurrentFoci);
												OAi.add(iter-1,CurrentFoci.FOindex);
											}
										} else {
											//IJ.log("added 2");
											OA.add(iter-1,CurrentFoci);
											OAi.add(iter-1, CurrentFoci.FOindex);
											}																																		
									}
								} else { // Multiple instances to check
									//IJ.log("multiple");
									double theta[];
									theta = new double[2];
									
									for (int kk=0;kk<indicesOAi.length;kk++){
										double x_now = OA.getreal(iter+curSp-1,indicesOAi[kk]).x_coord;
										double y_now = OA.getreal(iter+curSp-1,indicesOAi[kk]).y_coord;
										//IJ.log(""+kk+","+(iter+curSp-2)+", "+indicesOAi.length+", "+spaceindex);
										//IJ.log(""+OA.OA[iter+curSp-2].size());
										double x_prev = OA.getreal(iter+curSp-2,indicesOAi[kk]).x_coord; 
										double y_prev = OA.getreal(iter+curSp-2,indicesOAi[kk]).y_coord;
										
										double vector1 = Math.sqrt(((x_coord[objnum]-x_now)*(x_coord[objnum]-x_now))+((y_coord[objnum]-y_now)*(y_coord[objnum]-y_now)));
										double vector2 = Math.sqrt(((x_coord[objnum]-x_prev)*(x_coord[objnum]-x_prev))+((y_coord[objnum]-y_prev)*(y_coord[objnum]-y_prev)));
									
										double dot = ((x_now-x_coord[objnum])*(x_prev-x_coord[objnum]))+((y_now-y_coord[objnum])*(y_prev-y_coord[objnum]));
										theta[kk] = Math.acos(dot/(vector1*vector2));
										theta[kk] = Math.abs(theta[kk]-Math.PI/2);
									}
									double[] thetaori = theta;
									Arrays.sort(theta);
									
									// Find index
									for (int sorter=0;sorter<theta.length;sorter++){
										if (thetaori[sorter] == theta[0]){
											OA.set(iter-1, indicesOAi[sorter], CurrentFoci);
											OAi.set(iter-1, indicesOAi[sorter], CurrentFoci.FOindex);
										}
									}
								}
									
							} else {
								OA.add(iter-1,CurrentFoci);
								OAi.add(iter-1, CurrentFoci.FOindex);
							}
						}
					}
					objnum++;
					if (objnum==frame.length){
						break;
					}
				}	
				OA.resize(iter-1);
				OAi.resize(iter-1);
			}					
		}
		// Now return the ObjectArray
		//OA.print();
		//OAi.print();
		IJ.log("Tracking done!");
		//PlotData.plot(OAi, OA);
		PlotDataJoost.plot(OAi,OA, ColorSet, imp);  //edited out but dont know why feb 2016
		PlotData.plot(OAi, OA, Data.directory);
   //same
		}
	}


