package LeidenUniv.Tracking;

import ij.*;
import ij.gui.*;
import java.awt.*;

import ij.measure.ResultsTable;
import ij.plugin.PlugIn;
import java.io.*;
import java.util.*;
import ij.plugin.frame.RoiManager;
import ij.plugin.filter.*;

public class PlotData {
	
	static double[][] MSDmatrix;
	static double[][] Distmatrix;
	static double[][] Movematrix;
	static float[][] 
XMatrix;
	static float[][] YMatrix;
	static Roi[][] RoiMatrix;
	
	static double[] AvDis; 	
	static double[] AvMSD;

	public static void plot(OAindices OAi, ObjectArray OA, String dir, ImagePlus imp, double AvRad){	
		
		MSDmatrix = new double[OAi.size(0)][OAi.sizeofOAindices];
		Distmatrix = new double[OAi.size(0)][OAi.sizeofOAindices];
		Movematrix = new double[OAi.size(0)][OAi.sizeofOAindices];
		XMatrix =new float[OAi.size(0)][OAi.sizeofOAindices];
		YMatrix =new float[OAi.size(0)][OAi.sizeofOAindices];
		RoiMatrix = new Roi[OAi.size(0)][OAi.sizeofOAindices];
		
		AvDis = new double[OAi.sizeofOAindices];		
		AvMSD = new double[OAi.sizeofOAindices];
		double maxDist=0;
		double maxMSD=0;

		RoiManager sortRoi=new RoiManager();
		int countRois=0;
		imp.hide();
		for (int ii=0;ii<OAi.size(0);ii++){
			for (int jj=0;jj<OAi.sizeofOAindices;jj++){
				if (OAi.getreal(jj,ii)!=0){
					XMatrix[ii][jj]=(float)OA.getreal(jj,ii).x_coord;
					YMatrix[ii][jj]=(float)OA.getreal(jj,ii).y_coord;
					RoiMatrix[ii][jj]=OA.getreal(jj,ii).roi; // this creates the 2dimensional roi array of all tracks
					sortRoi.addRoi(OA.getreal(jj,ii).roi);
					sortRoi.select(countRois);
					sortRoi.runCommand("Rename", "Obj "+ii+ ", Part "+ jj);
					countRois++;
					
				}
			}
		}
		sortRoi.runCommand("Save", dir+"\\RoiTracks.zip");
		imp.show();
		
		for (int i=0; i<OAi.size(0); i++){ // loop through rows		
			
			double prevd;
			int index=1;
			
			for (int j=0; j<OAi.sizeofOAindices-1; j++){ // loop through cols	
				double summsd=0; //no data added yet.
				int count=0;
				for (int k=0; k<OAi.sizeofOAindices-index; k++){
					if (OAi.getreal(k,i)!=0 && OAi.getreal(k+index,i)!=0){	
// check if there are values present
						count+=1; //something is added.
				
						double x_val = OA.getreal(k,i).x_coord;
						double y_val = OA.getreal(k,i).y_coord;
						
						double x_val_next = OA.getreal(k+index,i).x_coord;
						double y_val_next = OA.getreal(k+index,i).y_coord;
						
						summsd += (((x_val-x_val_next)*(x_val-x_val_next))+((y_val-y_val_next)*(y_val-y_val_next)));
					} 
				}
				MSDmatrix[i][j]=summsd/count;
				if (MSDmatrix[i][j]>maxMSD){
					maxMSD=MSDmatrix[i][j];
				}
				index+=1;
				if (j==0){
					prevd=0;
				} else {
					prevd=Distmatrix[i][j-1];
				}
				if (OAi.getreal(j,i)!=0 && OAi.getreal(j+1,i)!=0){
					Distmatrix[i][j]=prevd+Math.sqrt((OA.getreal(j,i).x_coord-OA.getreal(j+1,i).x_coord)*(OA.getreal(j,i).x_coord-OA.getreal(j+1,i).x_coord)+(OA.getreal(j,i).y_coord-OA.getreal(j+1,i).y_coord)*(OA.getreal(j,i).y_coord-OA.getreal(j+1,i).y_coord));
					Movematrix[i][j]=Math.sqrt((OA.getreal(j,i).x_coord-OA.getreal(j+1,i).x_coord)*(OA.getreal(j,i).x_coord-OA.getreal(j+1,i).x_coord)+(OA.getreal(j,i).y_coord-OA.getreal(j+1,i).y_coord)*(OA.getreal(j,i).y_coord-OA.getreal(j+1,i).y_coord));
					if (Distmatrix[i][j]>maxDist){
						maxDist=Distmatrix[i][j];
					}
				} else {
					if (prevd==0){
						Distmatrix[i][j]=prevd;
					} else {
						Distmatrix[i][j]=Double.NaN;
					}
				}
			}	
		}
		
		IJ.log("MSDmatrix done!");

		double [] xval=new double [OAi.sizeofOAindices];
		for (int m=0;m<OAi.sizeofOAindices;m++){
			xval[m]=m;
		}
		
		Plot plot = new Plot("Total Displacement", "dt", "Displacement", xval, Distmatrix[0]);
		plot.setLimits(0,OAi.sizeofOAindices-2 , 0, maxDist); //might be needed still but check later
		
		
int iter=1;
		for (iter=1; iter<OAi.size(0); iter++){
			plot.addPoints(xval, Distmatrix[iter],PlotWindow.LINE);
			plot.draw();
		}


//////////////////////////////////////////
		
		for (int j=0; j<OAi.sizeofOAindices;j++){ //columns
		double sumd=0;
		int k=0;
			for (int i=0; i<OAi.size(0); i++){  //rows
				if (Distmatrix[i][j]>=0){
					k=k+1;
					sumd=sumd+Distmatrix[i][j];
				}
			}
			if (k>0){
				AvDis[j]=sumd/k; //line 196
			} else{
				AvDis[j]=0;
			}
		sumd=0;				
		}
		
		plot.setLineWidth(2);
		plot.setColor(Color.red);
		plot.addPoints(xval, AvDis,PlotWindow.LINE);
		plot.setColor(Color.black);
		
		plot.show();

//-------------------------------------------

		int iter2=1;
		Plot plot2 = new Plot("MSD", "dt", "Displacement", xval, MSDmatrix[0]);
		plot2.setLimits(0,OAi.sizeofOAindices-2 , 0, maxMSD); //might be needed still but check later
		
		for (iter2=1; iter2<OAi.size(0)-1; iter2++){
			plot2.addPoints(xval, MSDmatrix[iter2],PlotWindow.LINE);
			plot2.draw();
		}
		
		double[] AvMSD = new double[OAi.sizeofOAindices];
		double sumd=0;
		for (int j=0; j<OAi.sizeofOAindices-1;j++){ //columns
			int k=0;
			for (int i=0; i<MSDmatrix.length; i++){  //rows
				if (MSDmatrix[i][j]>0){
					k=k+1;
					sumd=sumd+MSDmatrix[i][j];
				}
			}
			if (k>0){
				AvMSD[j]=sumd/k; //line 196
			} else{
				AvMSD[j]=0;
			}
		sumd=0;				
		}
		plot2.setLineWidth(2);
		plot2.setColor(Color.red);
		plot2.addPoints(xval, AvMSD,PlotWindow.LINE);
		plot2.setColor(Color.black);
		plot2.show();

		// this is the time to make transfer the xmatrix and ymatrix into an ROI list
		SpeedHeatMap SHM = new SpeedHeatMap();
		SHM.run(XMatrix, YMatrix, imp, AvRad, dir);
		


		// here we need to save the data
		try {
			PrintWriter out = new PrintWriter(dir+"Locations.csv");
			out.println("\"sep=,\"");
			out.println((Arrays.deepToString(XMatrix).replace("[","")).replace("],","\n").replace("]]",""));
			out.println("\n\n");
			out.println((Arrays.deepToString(YMatrix).replace("[","")).replace("],","\n").replace("]]",""));
			out.close();
			PrintWriter out2 = new PrintWriter(dir+"MSD.csv");
			out2.println("\"sep=,\"");
			String MSDout = "0,"+ Arrays.deepToString(MSDmatrix).replace("[[","").replace("[","").replace(", 0.0]]","").replace(", 0.0],","\n0").replace("NaN","").replace(" ","");
			out2.println(MSDout);
			out2.close();
			PrintWriter out3 = new PrintWriter(dir+"TD.csv");
			out3.println("\"sep=,\"");
			String DistOut="0,"+(Arrays.deepToString(Distmatrix).replace("[[",",").replace("[","")).replace(", 0.0]]","").replace(", 0.0]","\n0").replace(" ","");
			out3.println(DistOut);
			out3.close();
			PrintWriter out4 = new PrintWriter(dir+"Steps.csv");
			out4.println("\"sep=,\"");
			String MoveOut= "0,"+(Arrays.deepToString(Movematrix).replace("[[",",").replace("[","")).replace(", 0.0]]","").replace(", 0.0]","\n0").replace(" ","");
			out4.println(MoveOut);
			out4.close();
			
		}catch (Exception e){
			IJ.log(e.toString());
		}
	}
	
}




